#include <iostream>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);cout.tie(0);

    int n, q;
    cin >> n >> q;
    int niz[n];
    int Dk[n];
    int Pk[n];
    for (int i =0; i<n; i++){
        cin >> Dk[i] >> Pk[i];
    }
    for (int i = 0; i<q; i++){
        int H;
        cin >> H;
        bool uslov2 = true;

        for (int j =0; j<n; j++){
            niz[j]=0;
        }
        for (int j =0; j<n; j++){
            int p=Pk[j];
            int d=Dk[j];
            bool uslov1=false;
            for(int l=j; l<n; l++){
                niz[l]+=max(d, p);
                p+=Pk[j];


                if (niz[j]>=H){
                    cout << j+1 << "\n";
                    uslov1=true;
                    uslov2=false;
                    break;
                }

            }
            /*or (int j =0; j<n; j++){
                cout << niz[j] << " ";
            }cout <<"\n";*/

            if (uslov1){break;}


            if (uslov1){break;}



        }
        if (uslov2){cout << -1 << "\n";}
    }

    return 0;
}